org.apache.struts2.jasper

## Class JspCompilationContext

- java.lang.Object
- - org.apache.struts2.jasper.JspCompilationContext

-     public class JspCompilationContext
      extends Object

  A place holder for various things that are used through out the JSP engine. This is a per-request/per-context data structure. Some of the instance variables are set at different points. Most of the path-related stuff is here - mangling names, versions, dirs, loading resources and dealing with uris.
  Author:
    Anil K. Vijendran, Harish Prabandham, Pierre Delisle, Costin Manolache, Kin-man Chung

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `basePackageName`
    `protected String` | `baseURI`
    `protected URL` | `baseUrl`
    `protected String` | `classFileName`
    `protected String` | `className`
    `protected String` | `classPath`
    `protected String` | `contentType`
    `protected javax.servlet.ServletContext` | `context`
    `protected String` | `derivedPackageName`
    `protected boolean` | `isErrPage`
    `protected boolean` | `isPackagedTagFile`
    `protected boolean` | `isTagFile`
    `protected String` | `javaPath`
    `protected Compiler` | `jspCompiler`
    `protected URLClassLoader` | `jspLoader`
    `protected String` | `jspUri`
    `protected JspServletWrapper` | `jsw`
    `protected ClassLoader` | `loader`
    `protected org.apache.juli.logging.Log` | `log`
    `protected Options` | `options`
    `protected String` | `outputDir`
    `protected boolean` | `protoTypeMode`
    `protected JspRuntimeContext` | `rctxt`
    `protected int` | `removed`
    `protected Class` | `servletClass`
    `protected String` | `servletJavaFileName`
    `protected URL` | `tagFileJarUrl`
    `protected Map<String,URL>` | `tagFileJarUrls`
    `protected javax.servlet.jsp.tagext.TagInfo` | `tagInfo`
    `protected ServletWriter` | `writer`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JspCompilationContext(String jspUri, boolean isErrPage, Options options, javax.servlet.ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, ClassLoaderInterface classLoaderInterface)`
    `JspCompilationContext(String tagfile, javax.servlet.jsp.tagext.TagInfo tagInfo, Options options, javax.servlet.ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, URL tagFileJarUrl)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static String` | `canonicalURI(String s)`
    `void` | `checkOutputDir()`
    `void` | `compile()`
    `Compiler` | `createCompiler()`
    `protected Compiler` | `createCompiler(String className)`
    `protected void` | `createOutputDir()`
    `String` | `getClassFileName()`
    `ClassLoader` | `getClassLoader()`
    `String` | `getClassPath()`
    `Compiler` | `getCompiler()`
    `String` | `getContentType()`
    `protected String` | `getDerivedPackageName()`
    `String` | `getJavaPath()`
    `String` | `getJspFile()`
    `ClassLoader` | `getJspLoader()`
    `Options` | `getOptions()`
    `String` | `getOutputDir()`
    `String` | `getRealPath(String path)`
    `URL` | `getResource(String res)`
    `InputStream` | `getResourceAsStream(String res)` Gets a resource as a stream, relative to the meanings of this context's implementation.
    `Set` | `getResourcePaths(String path)`
    `JspRuntimeContext` | `getRuntimeContext()`
    `String` | `getServletClassName()`
    `javax.servlet.ServletContext` | `getServletContext()`
    `String` | `getServletJavaFileName()`
    `String` | `getServletPackageName()`
    `String` | `getSourceCode()`
    `URL` | `getTagFileJarUrl()`
    `URL` | `getTagFileJarUrl(String tagFile)`
    `javax.servlet.jsp.tagext.TagInfo` | `getTagInfo()`
    `String[]` | `getTldLocation(String uri)` Gets the 'location' of the TLD associated with the given taglib 'uri'.
    `ServletWriter` | `getWriter()`
    `void` | `incrementRemoved()`
    `boolean` | `isErrorPage()`
    `protected static boolean` | `isPathSeparator(char c)`
    `boolean` | `isPrototypeMode()`
    `boolean` | `isRemoved()`
    `boolean` | `isTagFile()`
    `boolean` | `keepGenerated()`
    `Class` | `load()`
    `protected boolean` | `makeOutputDir()`
    `String` | `resolveRelativeUri(String uri)` Get the full value of a URI relative to this compilations context uses current file as the base.
    `void` | `setClassLoader(ClassLoader loader)`
    `void` | `setClassPath(String classPath)`
    `void` | `setContentType(String contentType)`
    `void` | `setErrorPage(boolean isErrPage)`
    `void` | `setPrototypeMode(boolean pm)`
    `void` | `setServletClassName(String className)`
    `void` | `setServletPackageName(String servletPackageName)`
    `void` | `setSourceCode(String sourceCode)`
    `void` | `setTagFileJarUrl(String tagFile, URL tagFileURL)`
    `void` | `setTagInfo(javax.servlet.jsp.tagext.TagInfo tagi)`
    `void` | `setWriter(ServletWriter writer)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### log

          protected org.apache.juli.logging.Log log

    - #### tagFileJarUrls

          protected Map<String,URL> tagFileJarUrls

    - #### isPackagedTagFile

          protected boolean isPackagedTagFile

    - #### className

          protected String className

    - #### jspUri

          protected String jspUri

    - #### isErrPage

          protected boolean isErrPage

    - #### basePackageName

          protected String basePackageName

    - #### derivedPackageName

          protected String derivedPackageName

    - #### servletJavaFileName

          protected String servletJavaFileName

    - #### javaPath

          protected String javaPath

    - #### classFileName

          protected String classFileName

    - #### contentType

          protected String contentType

    - #### writer

          protected ServletWriter writer

    - #### options

          protected Options options

    - #### jsw

          protected JspServletWrapper jsw

    - #### jspCompiler

          protected Compiler jspCompiler

    - #### classPath

          protected String classPath

    - #### baseURI

          protected String baseURI

    - #### outputDir

          protected String outputDir

    - #### context

          protected javax.servlet.ServletContext context

    - #### loader

          protected ClassLoader loader

    - #### rctxt

          protected JspRuntimeContext rctxt

    - #### removed

          protected int removed

    - #### jspLoader

          protected URLClassLoader jspLoader

    - #### baseUrl

          protected URL baseUrl

    - #### servletClass

          protected Class servletClass

    - #### isTagFile

          protected boolean isTagFile

    - #### protoTypeMode

          protected boolean protoTypeMode

    - #### tagInfo

          protected javax.servlet.jsp.tagext.TagInfo tagInfo

    - #### tagFileJarUrl

          protected URL tagFileJarUrl

  - ### Constructor Detail

    - #### JspCompilationContext

          public JspCompilationContext(String jspUri,
                                       boolean isErrPage,
                                       Options options,
                                       javax.servlet.ServletContext context,
                                       JspServletWrapper jsw,
                                       JspRuntimeContext rctxt,
                                       ClassLoaderInterface classLoaderInterface)

    - #### JspCompilationContext

          public JspCompilationContext(String tagfile,
                                       javax.servlet.jsp.tagext.TagInfo tagInfo,
                                       Options options,
                                       javax.servlet.ServletContext context,
                                       JspServletWrapper jsw,
                                       JspRuntimeContext rctxt,
                                       URL tagFileJarUrl)

  - ### Method Detail

    - #### getClassPath

          public String getClassPath()

      Returns:
        The classpath that is passed off to the Java compiler.

    - #### setClassPath

          public void setClassPath(String classPath)

      Parameters:
        `classPath` - The classpath that is passed off to the Java compiler.

    - #### getClassLoader

          public ClassLoader getClassLoader()

      Returns:
        What class loader to use for loading classes while compiling this JSP?

    - #### setClassLoader

          public void setClassLoader(ClassLoader loader)

    - #### getJspLoader

          public ClassLoader getJspLoader()

    - #### getOutputDir

          public String getOutputDir()

      Returns:
        The output directory to generate code into. The output directory is make up of the scratch directory, which is provide in Options, plus the directory derived from the package name.

    - #### createCompiler

          public Compiler createCompiler()
                                  throws JasperException

      Returns:
        Create a "Compiler" object based on some init param data. This is not done yet. Right now we're just hardcoding the actual compilers that are created.
      Throws:
        `JasperException` - in case of Jasper errors

    - #### createCompiler

          protected Compiler createCompiler(String className)

    - #### getCompiler

          public Compiler getCompiler()

    - #### resolveRelativeUri

          public String resolveRelativeUri(String uri)

      Get the full value of a URI relative to this compilations context uses current file as the base.
      Parameters:
        `uri` - the URL
      Returns:
        full URL

    - #### getResourceAsStream

          public InputStream getResourceAsStream(String res)

      Gets a resource as a stream, relative to the meanings of this context's implementation.
      Parameters:
        `res` - resource
      Returns:
        a null if the resource cannot be found or represented as an InputStream.

    - #### getResource

          public URL getResource(String res)
                          throws MalformedURLException

      Throws:
        `MalformedURLException`

    - #### getResourcePaths

          public Set getResourcePaths(String path)

    - #### getRealPath

          public String getRealPath(String path)

      Parameters:
        `path` - the path
      Returns:
        the actual path of a URI relative to the context of the compilation.

    - #### getTagFileJarUrl

          public URL getTagFileJarUrl(String tagFile)

      Parameters:
        `tagFile` - The map is populated when parsing the tag-file elements of the TLDs of any imported taglibs.
      Returns:
        the tag-file-name-to-JAR-file map of this compilation unit, which maps tag file names to the JAR files in which the tag files are packaged.

    - #### setTagFileJarUrl

          public void setTagFileJarUrl(String tagFile,
                                       URL tagFileURL)

    - #### getTagFileJarUrl

          public URL getTagFileJarUrl()

      Returns:
        the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.

    - #### getServletClassName

          public String getServletClassName()

      Returns:
        Just the class name (does not include package name) of the generated class.

    - #### setServletClassName

          public void setServletClassName(String className)

    - #### getJspFile

          public String getJspFile()

      Returns:
        Path of the JSP URI. Note that this is not a file name. This is the context rooted URI of the JSP file.

    - #### isErrorPage

          public boolean isErrorPage()

      Returns:
        Are we processing something that has been declared as an errorpage?

    - #### setErrorPage

          public void setErrorPage(boolean isErrPage)

    - #### isTagFile

          public boolean isTagFile()

    - #### getTagInfo

          public javax.servlet.jsp.tagext.TagInfo getTagInfo()

    - #### setTagInfo

          public void setTagInfo(javax.servlet.jsp.tagext.TagInfo tagi)

    - #### isPrototypeMode

          public boolean isPrototypeMode()

      Returns:
        True if we are compiling a tag file in prototype mode. ie we only generate codes with class for the tag handler with empty method bodies.

    - #### setPrototypeMode

          public void setPrototypeMode(boolean pm)

    - #### getServletPackageName

          public String getServletPackageName()

      Returns:
        Package name for the generated class is make up of the base package name, which is user settable, and the derived package name. The derived package name directly mirrors the file heirachy of the JSP page.

    - #### getDerivedPackageName

          protected String getDerivedPackageName()

    - #### setServletPackageName

          public void setServletPackageName(String servletPackageName)

      Parameters:
        `servletPackageName` - The package name into which the servlet class is generated.

    - #### getServletJavaFileName

          public String getServletJavaFileName()

      Returns:
        Full path name of the Java file into which the servlet is being generated.

    - #### getOptions

          public Options getOptions()

      Returns:
        Get hold of the Options object for this context.

    - #### getServletContext

          public javax.servlet.ServletContext getServletContext()

    - #### getRuntimeContext

          public JspRuntimeContext getRuntimeContext()

    - #### getJavaPath

          public String getJavaPath()

      Returns:
        Path of the Java file relative to the work directory.

    - #### getClassFileName

          public String getClassFileName()

    - #### getContentType

          public String getContentType()

      Returns:
        Get the content type of this JSP. Content type includes content type and encoding.

    - #### setContentType

          public void setContentType(String contentType)

    - #### getWriter

          public ServletWriter getWriter()

      Returns:
        Where is the servlet being generated?

    - #### setWriter

          public void setWriter(ServletWriter writer)

    - #### getTldLocation

          public String[] getTldLocation(String uri)
                                  throws JasperException

      Gets the 'location' of the TLD associated with the given taglib 'uri'.
      Parameters:
        `uri` - the URL
      Returns:
        An array of two Strings: The first element denotes the real path to the TLD. If the path to the TLD points to a jar file, then the second element denotes the name of the TLD entry in the jar file. Returns null if the given uri is not associated with any tag library 'exposed' in the web application.
      Throws:
        `JasperException` - in case of Jasper errors

    - #### keepGenerated

          public boolean keepGenerated()

      Returns:
        Are we keeping generated code around?

    - #### incrementRemoved

          public void incrementRemoved()

    - #### isRemoved

          public boolean isRemoved()

    - #### compile

          public void compile()
                       throws JasperException,
                              FileNotFoundException

      Throws:
        `JasperException`
        `FileNotFoundException`

    - #### load

          public Class load()
                     throws JasperException,
                            FileNotFoundException

      Throws:
        `JasperException`
        `FileNotFoundException`

    - #### checkOutputDir

          public void checkOutputDir()

    - #### makeOutputDir

          protected boolean makeOutputDir()

    - #### createOutputDir

          protected void createOutputDir()

    - #### isPathSeparator

          protected static final boolean isPathSeparator(char c)

    - #### canonicalURI

          protected static final String canonicalURI(String s)

    - #### getSourceCode

          public String getSourceCode()

    - #### setSourceCode

          public void setSourceCode(String sourceCode)

Copyright © 2000–2022 Apache Software Foundation. All rights reserved.